KNIFE-DEPS(1)

NAME
knife-deps - The man page for the knife deps subcommand.

The knife deps subcommand is used to identify dependencies for a node, role, or cookbook.

Syntax

This argument has the following syntax:

$ knife deps (options)

Options

This subcommand has the following options:

-c CONFIG_FILE, --config CONFIG_FILE
    The configuration file to use.

--chef-repo-path PATH
    The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by chef_repo_path in config.rb.

--chef-zero-port PORT
    The port on which chef-zero will listen.

--[no-]color
    Indicates whether colored output will be used.

--concurrency
    The number of allowed concurrent connections. Default: 10.

-d, --disable-editing
    Indicates that $EDITOR will not be opened; data will be accepted as-is.

--defaults
    Indicates that Knife will use the default value, instead of asking a user to provide one.

-e EDITOR, --editor EDITOR
    The $EDITOR that is used for all interactive commands.

-E ENVIRONMENT, --environment ENVIRONMENT
    The name of the environment. When this option is added to a command, the command will run only against the named environment.

-F FORMAT, --format FORMAT
    The output format: summary (default), text, json, yaml, and pp.

-h, --help
    Shows help for the command.

-k KEY, --key KEY
    The private key that Knife will use to sign requests made by the API client to the server.

--print-after
    Indicates that data will be shown after a destructive operation.

--[no-]recurse
    Use --recurse to list dependencies recursively. This option can only be used when --tree is set to true. Default: --no-recurse.

--remote
    Indicates that dependencies will be determined from objects located on the server instead of the local chef-repo. Default: false.

--repo-mode MODE
    The layout of the local chef-repo. Possible values: static, everything, or hosted_everything. Use static for just roles, environments, cookbooks, and data bags. By default, everything and hosted_everything are dynamically selected depending on the server type. Default: everything / hosted_everything.

-s URL, --server-url URL
    The URL for the server.

--tree
    Indicates that dependencies are shown in a visual tree structure (including duplicates, if they exist). Default: false.

-u USER, --user USER
    The user name used by Knife to sign requests made by the API client to the server. Authentication will fail if the user name does not match the private key.

-v, --version
    The version of the chef-client.

-V, --verbose
    Set for more verbose outputs. Use -VV for maximum verbosity.

-y, --yes
    Indicates that the response to all confirmation prompts will be "Yes" (and that Knife will not ask for confirmation).

-z, --local-mode
    Indicates that the chef-client will be run in local mode, which allows all commands that work against the server to also work against the local chef-repo.

    Examples

    $ knife deps nodes/node_name.json

    $ knife deps roles/role_name.json

    $ knife deps cookbooks/cookbook_name.json

    $ knife deps environments/environment_name.json

    To find the dependencies for a combination of nodes, cookbooks, roles, and/or environments:

    $ knife deps cookbooks/git.json cookbooks/github.json roles/base.json environments/desert.json nodes/mynode.json

    A wildcard can be used to return all of the child nodes. For example, all of the environments:

    $ knife deps environments/*.json

    Use the --tree option to view the results with structure:

    $ knife deps roles/webserver.json

    to return something like:

    roles/webserver.json
      roles/base.json
        cookbooks/github
          cookbooks/git
        cookbooks/users
      cookbooks/apache2

    The output of knife deps can be passed to knife upload:

    $ knife upload `knife deps nodes/*.json

    The output of knife deps can be passed to knife xargs:

    $ knife deps nodes/*.json | xargs knife upload

AUTHOR
Chef